module Test where

--Aufgabe 1

data Liste a = Ende | E a (Liste a) deriving (Eq,Ord,Show)

streiche :: Ord a => (Liste a) -> (Liste a) -> (Liste a)
streiche Ende _ = Ende
streiche (E a l) Ende = (E a l)
streiche (E a l) l' = 
    let cont = contains' a l' in
    if cont
    then streiche l l'
    else (E a) (streiche l l')

contains' :: Ord a => a -> (Liste a) -> Bool
contains' a Ende = False
contains' a (E a' l) = if a == a' then True else contains' a l

{-
 - Knapp, aber gut nachvollziehbar, geht die Implementierung von 'streiche' folgendermaßen vor:
 -
 - Funktion geht die Liste rekursiv durch und ruft dabei immer wieder contains' auf. Je nachdem,
 - ob der Wert in der zweiten Liste vorhanden ist, wird der zur Zeit betrachtete Wert im nächsten
 - rekursiven Funktionsaufruf wieder betrachet.
 -}

--Aufgabe 2

{-
 - 1.
 - 
 - 'Liste a' ist ein Summentyp, da er zwei Konstruktoren besitzt, wobei einer ('E') ein
 - nicht-nullstelliger Konstruktor ist.
 -
 - 2.
 -
 - data Liste a = Ende | a :-> (List a) deriving (Eq,Ord,Show)
 - 
 - 4 :-> 2 :-> 0 :-> 3 :-> 2 :-> 4 :-> Ende
 -
 - 3. 
 -
 - instance (Eq a) => Eq (Liste a) where
 - l == l' = checkEq l l'

 - checkEq :: Eq a => (Liste a) -> (Liste a) -> Bool
 - checkEq Ende Ende = True
 - checkEq Ende _ = False
 - checkEq _ Ende = False
 - checkEq (E a l) (E a' l') = 
 -    if a == a'
 -    then checkEq l l'
 -    else False
 - checkEq _ _ = False
 -
 ----------------------------------------------------------
 -
 - instance (Ord a) => Ord (Liste a) where
 - l <= l' = checkOrd l l'
 -
 - checkOrd :: Ord a => (Liste a) -> (Liste a) -> Bool
 - checkOrd Ende Ende = True
 - checkOrd Ende _ = False
 - checkOrd _ Ende = False
 - checkOrd (E a l) (E a' l') = 
 -    if a <= a'
 -    then checkEq l l'
 -    else False
 - checkOrd _ _ = False
 -
 ----------------------------------------------------------
 -
 - instance (Show a) => Show (Liste a) where
 -    show = show'

 - show' :: (Show a) => (Liste a) -> String
 - show' Ende = "Ende"
 - show' (E a l) = "(E " ++ (show a) ++ (show' l) ++ " )"
 -
 - 4.
 - 
 - 'E' ist ein einstelliger Konstruktor, 'Ende' ist ein nullstelliger Konstruktor.
 - Ende:: Liste a
 - E:: a -> Liste a -> Liste a
 -
 - 5.
 -
 - 'streiche' ist ad hoc (unecht) polymorph, da 'a' Instanz von Ord sein muss (==Einschränkung).
 -
 - 6.
 -
 - 'Liste a' genügt dem Hauptleitsatz funktionaler Programmierung, da der Typ von 'a' nicht weiter eingeschränkt
 - ist - er ist echt polymorph. 
 - 'streiche' ist dahingegen ad hoc polymorph. 'a' ist hierbei aber mehr eingeschränkt, als notwendig. Um
 - Vergleiche zwischen zwei Listen zu machen, muss lediglich auf Gleichheit geprüft werden. Dafür würde
 - bereits reichen, dass 'a' Instanz von Eq ist. Durch Ord ist 'a' somit mehr eingeschränkt, als unbedingt
 - notwendig, wodurch der Hauptleitsatz funktionaler Programmierung verletzt ist.
 -}

--Aufgabe 3

data Baum = Blatt Integer String | Gabel Integer ((Integer,Integer) -> Bool) Baum Baum

{-
 - 2.
 -
 - a)
 -
 - (Blatt 3 "Fun")
 -
 - b)
 -
 - (Gabel 42 (\(x,y) -> mod x 42 == y)(Blatt 6 "Haskell")(Gabel 17 (\(x,y) -> x > y)(Blatt 6 "Brooks")(Blatt 5 "Curry")))
 -
 -
 -
 -          (Gabel 42 (\(x,y) -> mod x 42 == y) 
 -            /                       \
 - (Blatt 6 "Haskell")        (Gabel 17 (\(x,y) -> x > y)
 -                               /             \
 -                  (Blatt 6 "Brooks")    (Blatt 5 "Curry")))
 -
 - c)
 -
 - Per Angabe, ja. Aber per definitionem, nein. Man hätte ihn komplett allgemein definieren können.
 -}

--Aufgabe 4

{-
 - 1.
 -
 - Das Ziel von Alonzo Church war, ein formales Berechnungsmodell zu finden, um Fragen der Natur von 
 - Berechnung und dessen, was berechnet wird, zu fassen & zu untersuchen. Es ist in diesem Sinne ein
 - universelles Berechnungsmodell.
 -
 - 2. 
 -
 - Ja, denn das lambda-Kalkül ist einfach, ausdruckskräftig und praxisorientiert(er als Konkurrenten). Des
 - Weiteren bildet es die Grundlage aller funktionalen Programmiersprachen und dient als Bindeglied
 - funktionaler Hochsprachen und maschinennaher Implementierungen.
 - 
 - 3.
 -
 - Das lambda-Kalkül ist die Grundlage aller funktionalen Programmiersprachen (gilt als 'Assembler-Sprache'
 - funktionaler Programmierung).
 -
 -}

--Aufgabe 5

{- 
 - 1. Falsch. Sie haben zwar keinen Einfluss auf Typsicherheit, leisten aber einen bedeutsamen Beitrag 
 - zur Lesbarkeit, Verständlichkeit und Transparenz von und in Programmen.
 -
 - 2. Falsch. Sollte ein lambda-Term eine Normalform haben, so gibt es eine Sequenz an beta-Reduktionen, welche
 - zu genau dieser Normalform führen. Angenommen, der lambda-Term besitzt genau einen beta-Redex (welcher widerum 
 - zum ursprünglichen lambda-Term zurückführt) und befindet sich noch nicht in Normalform. So kann es keine
 - Folge an beta-Reduktionen geben, welche zu einer Normalform führt. Stichwort "Endlosschleife"!!!
 -
 - Wenn ein lambda-Term in einer Endlosschleife feststeckt, dann hat er keine Normalform. In diesem Fall kann man
 - auch nicht von einer "eindeutigen Normalform" sprechen. Er führt bei der Reduktion immer wieder auf sich selbst.
 - (bei Interesse siehe "Omega-Kombinator")
 -
 - 3. Falsch. Bei f wird als zweiter Parameter eine Funktion genommen. g besitzt dahingegen 3 Parameter.
 -
 - Aufpassen auf Curry! 'f' und 'g' sehen "eigentlich" so aus:
 -			f :: ( [a] -> ( (a -> b) -> [b] ) )
 -			g :: ( [a] -> ( a -> ( b -> ( [b] ) ) ) )
 -}

--Aufgabe 6 (funktioniert, aber stolz bin ich ned drauf)

type Nat1 = Int
type Euro = Nat1
type Preis = Euro

data Artikel = A1 | A2 | A3 | A4 | A5 deriving (Eq, Ord, Show)
type Warenkatalog = (Artikel -> Preis)
data Haendler = H1 | H2 | H3 deriving (Eq, Ord, Show)

type Markt = (Haendler -> Warenkatalog)
type BestBieter = (Artikel -> (Artikel,Haendler,Preis))

g :: Markt -> BestBieter
g m = g' m

g' :: Markt -> Artikel -> (Artikel, Haendler, Preis)
g' m a = 
    let x = map m [H1,H2,H3] --Array an Warenkatalogen (Artikel -> Preis)
    in
    gettup x [H1,H2,H3] a

gettup :: [Warenkatalog] -> [Haendler] -> Artikel -> (Artikel,Haendler,Preis)
gettup [] [] _ = (A1, H1, -1) --base case nur als Kontrolle, dass array(s) durchlaufen wurde(n)
gettup (x:xs) (h:hs) a = 
    let y = x a
        z = gettup xs hs a
    in 
    if y < (thd z) || (thd z) == -1 then (a,h,y) else z

thd :: (a,b,c) -> c
thd (_,_,c) = c

{-
 - Knapp, aber gut nachvollziehbar, geht die Implementierung von 'g' folgendermaßen vor:
 -
 - 'g' delegiert Aufrufe mit beliebigem Artikel auf g'. Die Funktion 'Markt' wird dabei auf alle
 - möglichen Händler angewandt und das resultierende Array an Funktionen 'Warenkatalog' an
 - die Funktion 'gettup' weitergeleitet. Diese Funktion gibt das 3-Tupel anschließend zurück - um
 - den jeweiligen Händler noch im Tupel zurückzugeben, wird auch eine gesamte Liste an Händlern in
 - korrekter Reihenfolge (passend zur Warenkatalogsliste) an gettup übergeben. gettup durchläuft die
 - beiden Listen und sucht den Händler mit dem niedrigsten Preis heraus, gibt diesen anschließend
 - als gefordertes 3-Tupel zurück. Die Funktion thd ist hierbei nur eine Hilfsfunktion, welche das
 - dritte Element eines 3-Tupels zurückgibt.
 -}
